diff --git a/drupal7/sites/all/modules/date/date_repeat/tests/date_repeat.test b/drupal7/sites/all/modules/date/date_repeat/tests/date_repeat.test
index fc4e5c3c..83a5fa5b 100644
--- a/drupal7/sites/all/modules/date/date_repeat/tests/date_repeat.test
+++ b/drupal7/sites/all/modules/date/date_repeat/tests/date_repeat.test
@@ -4,7 +4,9 @@
  * @file
  * Test Date Repeat calculations.
  */
-
+/**
+ *
+ */
 class DateRepeatTestCase extends DrupalWebTestCase {
   public static function getInfo() {
     return array(
@@ -17,17 +19,19 @@ class DateRepeatTestCase extends DrupalWebTestCase {
   /**
    * Implements setUp().
    */
-  public function setUp() {
+  public function setUp(array $modules = array()) {
     // Load the date_repeat module.
-    parent::setUp('date_api', 'date_repeat');
+    $modules[] = 'date_api';
+    $modules[] = 'date_repeat';
+    parent::setUp($modules);
   }
 
   public function testDateRepeat() {
-    require_once('./' . drupal_get_path('module', 'date_api') . '/date_api_ical.inc');
-    require_once('./' . drupal_get_path('module', 'date_repeat') . '/date_repeat_calc.inc');
+    require_once './' . drupal_get_path('module', 'date_api') . '/date_api_ical.inc';
+    require_once './' . drupal_get_path('module', 'date_repeat') . '/date_repeat_calc.inc';
+
     // Examples adapted from http://www.faqs.org/rfcs/rfc2445.html and
     // http://www.kanzaki.com/docs/ical/rrule.html.
-
     //  Invalid value:
     $start = "1997-09-02 09:00:00";
     $end = "1997-09-30 09:00:00";
@@ -48,7 +52,7 @@ class DateRepeatTestCase extends DrupalWebTestCase {
     $result = implode(', ', $dates);
     $this->assertEqual($result, $shouldbe, $rule . '; Starting ' . $start . ';  results: ' . $result);
 
-    //Daily until September 24, 1997:
+    // Daily until September 24, 1997:
     $start = "1997-09-02 09:00:00";
     $end = "1997-09-30 09:00:00";
     $rule = "RRULE:FREQ=DAILY;UNTIL=19970924T000000Z";
@@ -58,7 +62,7 @@ class DateRepeatTestCase extends DrupalWebTestCase {
     $result = implode(', ', $dates);
     $this->assertEqual($result, $shouldbe, $rule . '; Starting ' . $start . ';  results: ' . $result);
 
-    //Every other day - until September 30:
+    // Every other day - until September 30:
     $start = "1997-09-02 09:00:00";
     $end = "1997-09-30 09:00:00";
     $rule = "RRULE:FREQ=DAILY;INTERVAL=2";
@@ -68,7 +72,7 @@ class DateRepeatTestCase extends DrupalWebTestCase {
     $result = implode(', ', $dates);
     $this->assertEqual($result, $shouldbe, $rule . '; Starting ' . $start . ';  results: ' . $result);
 
-    //Every 10 days, 2 occurrences:
+    // Every 10 days, 2 occurrences:
     $start = "1997-09-02 09:00:00";
     $end = "1997-09-30 09:00:00";
     $rule = "RRULE:FREQ=DAILY;INTERVAL=10;COUNT=2";
@@ -78,7 +82,7 @@ class DateRepeatTestCase extends DrupalWebTestCase {
     $result = implode(', ', $dates);
     $this->assertEqual($result, $shouldbe, $rule . '; Starting ' . $start . ';  results: ' . $result);
 
-    //Weekly for 3 occurrences
+    // Weekly for 3 occurrences.
     $start = "1997-09-02 09:00:00";
     $end = "1997-09-30 09:00:00";
     $rule = "RRULE:FREQ=WEEKLY;COUNT=3";
@@ -88,7 +92,7 @@ class DateRepeatTestCase extends DrupalWebTestCase {
     $result = implode(', ', $dates);
     $this->assertEqual($result, $shouldbe, $rule . '; Starting ' . $start . ';  results: ' . $result);
 
-    //Weekly until September 24, 1997
+    // Weekly until September 24, 1997
     $start = "1997-09-02 09:00:00";
     $end = "1997-09-30 09:00:00";
     $rule = "RRULE:FREQ=WEEKLY;UNTIL=19970924T000000Z";
@@ -98,7 +102,7 @@ class DateRepeatTestCase extends DrupalWebTestCase {
     $result = implode(', ', $dates);
     $this->assertEqual($result, $shouldbe, $rule . '; Starting ' . $start . ';  results: ' . $result);
 
-    //Every other week - forever:
+    // Every other week - forever:
     $start = "1997-09-02 09:00:00";
     $end = "1997-09-30 09:00:00";
     $rule = "RRULE:FREQ=WEEKLY;INTERVAL=2;WKST=SU";
@@ -108,7 +112,7 @@ class DateRepeatTestCase extends DrupalWebTestCase {
     $result = implode(', ', $dates);
     $this->assertEqual($result, $shouldbe, $rule . '; Starting ' . $start . ';  results: ' . $result);
 
-    //Weekly on Tuesday and Thursday for 4 weeks:
+    // Weekly on Tuesday and Thursday for 4 weeks:
     $start = "1997-09-02 09:00:00";
     $end = "1997-09-30 09:00:00";
     $rule = "RRULE:FREQ=WEEKLY;COUNT=8;WKST=SU;BYDAY=TU,TH";
@@ -118,7 +122,7 @@ class DateRepeatTestCase extends DrupalWebTestCase {
     $result = implode(', ', $dates);
     $this->assertEqual($result, $shouldbe, $rule . '; Starting ' . $start . ';  results: ' . $result);
 
-    //Every other week on Tuesday and Thursday, for 5 occurrences:
+    // Every other week on Tuesday and Thursday, for 5 occurrences:
     $start = "1997-09-02 09:00:00";
     $end = "1997-09-30 09:00:00";
     $rule = "RRULE:FREQ=WEEKLY;INTERVAL=2;COUNT=5;WKST=SU;BYDAY=TU,TH";
@@ -128,7 +132,7 @@ class DateRepeatTestCase extends DrupalWebTestCase {
     $result = implode(', ', $dates);
     $this->assertEqual($result, $shouldbe, $rule . '; Starting ' . $start . ';  results: ' . $result);
 
-    //Every other week on Monday, Wednesday and Friday until September 24, 1997,
+    // Every other week on Monday, Wednesday and Friday until September 24, 1997,
     $start = "1997-09-02 09:00:00";
     $end = "1997-09-30 09:00:00";
     $rule = "RRULE:FREQ=WEEKLY;INTERVAL=2;UNTIL=19970924T000000Z;WKST=SU;BYDAY=MO,WE,FR";
@@ -138,7 +142,7 @@ class DateRepeatTestCase extends DrupalWebTestCase {
     $result = implode(', ', $dates);
     $this->assertEqual($result, $shouldbe, $rule . '; Starting ' . $start . ';  results: ' . $result);
 
-    //Monthly on the 1st Friday for 2 occurrences:
+    // Monthly on the 1st Friday for 2 occurrences:
     $start = "1997-09-05 09:00:00";
     $end = "1997-10-31 09:00:00";
     $rule = "RRULE:FREQ=MONTHLY;COUNT=2;BYDAY=1FR";
@@ -148,7 +152,7 @@ class DateRepeatTestCase extends DrupalWebTestCase {
     $result = implode(', ', $dates);
     $this->assertEqual($result, $shouldbe, $rule . '; Starting ' . $start . ';  results: ' . $result);
 
-    //Monthly on the 1st Friday until December 24, 1997:
+    // Monthly on the 1st Friday until December 24, 1997:
     $start = "1997-09-05 09:00:00";
     $end = "1998-10-01 09:00:00";
     $rule = "RRULE:FREQ=MONTHLY;UNTIL=19971224T000000Z;BYDAY=1FR";
@@ -157,7 +161,7 @@ class DateRepeatTestCase extends DrupalWebTestCase {
     $result = implode(', ', $dates);
     $this->assertEqual($result, $shouldbe, $rule . '; Starting ' . $start . ';  results: ' . $result);
 
-    //Every other month on the 1st and last Sunday of the month for 10 occurrences:
+    // Every other month on the 1st and last Sunday of the month for 10 occurrences:
     $start = "1997-09-07 09:00:00";
     $end = "1998-10-01 09:00:00";
     $rule = "RRULE:FREQ=MONTHLY;INTERVAL=2;COUNT=10;BYDAY=1SU,-1SU";
@@ -170,11 +174,11 @@ class DateRepeatTestCase extends DrupalWebTestCase {
     $result = implode(', ', $dates);
     $this->assertEqual($result, $shouldbe, $rule . '; Starting ' . $start . ';  results: ' . $result);
 
-    //Monthly on the second to last Monday of the month for 6 months:
+    // Monthly on the second to last Monday of the month for 6 months:
     $start = "1997-09-22 09:00:00";
     $end = "1998-10-01 09:00:00";
     $rule = "RRULE:FREQ=MONTHLY;COUNT=6;BYDAY=-2MO";
-    //==> (1997 9:00 AM EDT)September 22;October 20
+    // ==> (1997 9:00 AM EDT)September 22;October 20
     //  (1997 9:00 AM EST)November 17;December 22
     //  (1998 9:00 AM EST)January 19;February 16
     $dates = date_repeat_calc($rule, $start, $end, array());
@@ -182,7 +186,7 @@ class DateRepeatTestCase extends DrupalWebTestCase {
     $result = implode(', ', $dates);
     $this->assertEqual($result, $shouldbe, $rule . '; Starting ' . $start . ';  results: ' . $result);
 
-    //Every Tuesday, every other month:
+    // Every Tuesday, every other month:
     $start = "1997-09-02 09:00:00";
     $end = "1998-02-01 09:00:00";
     $rule = "RRULE:FREQ=MONTHLY;INTERVAL=2;BYDAY=TU";
@@ -194,7 +198,7 @@ class DateRepeatTestCase extends DrupalWebTestCase {
     $result = implode(', ', $dates);
     $this->assertEqual($result, $shouldbe, $rule . '; Starting ' . $start . ';  results: ' . $result);
 
-    //Yearly in June and July for 10 occurrences:
+    // Yearly in June and July for 10 occurrences:
     $start = "1997-06-10 09:00:00";
     $end = "2002-01-01 09:00:00";
     $rule = "RRULE:FREQ=YEARLY;COUNT=10;BYMONTH=6,7";
@@ -204,13 +208,13 @@ class DateRepeatTestCase extends DrupalWebTestCase {
     //      (2000 9:00 AM EDT)June 10;July 10
     //      (2001 9:00 AM EDT)June 10;July 10
     //  Note: Since none of the BYDAY, BYMONTHDAY or BYYEARDAY components
-    //  are specified, the day is gotten from DTSTART
+    //  are specified, the day is gotten from DTSTART.
     $dates = date_repeat_calc($rule, $start, $end, array());
     $shouldbe = '1997-06-10 09:00:00, 1997-07-10 09:00:00, 1998-06-10 09:00:00, 1998-07-10 09:00:00, 1999-06-10 09:00:00, 1999-07-10 09:00:00, 2000-06-10 09:00:00, 2000-07-10 09:00:00, 2001-06-10 09:00:00, 2001-07-10 09:00:00';
     $result = implode(', ', $dates);
     $this->assertEqual($result, $shouldbe, $rule . '; Starting ' . $start . ';  results: ' . $result);
 
-    //Every other year on January, February, and March for 10 occurrences:
+    // Every other year on January, February, and March for 10 occurrences:
     $start = "1997-03-10 09:00:00";
     $end = "2004-01-01 09:00:00";
     $rule = "RRULE:FREQ=YEARLY;INTERVAL=2;COUNT=10;BYMONTH=1,2,3";
@@ -223,7 +227,7 @@ class DateRepeatTestCase extends DrupalWebTestCase {
     $result = implode(', ', $dates);
     $this->assertEqual($result, $shouldbe, $rule . '; Starting ' . $start . ';  results: ' . $result);
 
-    //An example where the days generated makes a difference because of WKST:
+    // An example where the days generated makes a difference because of WKST:
     $start = "1997-08-05 09:00:00";
     $end = "2004-01-01 09:00:00";
     $rule = "RRULE:FREQ=WEEKLY;INTERVAL=2;COUNT=4;BYDAY=TU,SU;WKST=MO";
@@ -233,7 +237,7 @@ class DateRepeatTestCase extends DrupalWebTestCase {
     $result = implode(', ', $dates);
     $this->assertEqual($result, $shouldbe, $rule . '; Starting ' . $start . ';  results: ' . $result);
 
-    //changing only WKST from MO to SU, yields different results...
+    // changing only WKST from MO to SU, yields different results...
     $start = "1997-08-05 09:00:00";
     $end = "2004-01-01 09:00:00";
     $rule = "RRULE:FREQ=WEEKLY;INTERVAL=2;COUNT=4;BYDAY=TU,SU;WKST=SU";
@@ -243,7 +247,7 @@ class DateRepeatTestCase extends DrupalWebTestCase {
     $result = implode(', ', $dates);
     $this->assertEqual($result, $shouldbe, $rule . '; Starting ' . $start . ';  results: ' . $result);
 
-    //Every 18 months on the 10th thru 15th of the month for 10 occurrences:
+    // Every 18 months on the 10th thru 15th of the month for 10 occurrences:
     $start = "1997-09-10 09:00:00";
     $end = "2004-01-01 09:00:00";
     $rule = "RRULE:FREQ=MONTHLY;INTERVAL=18;COUNT=10;BYMONTHDAY=10,11,12,13,14,15";
@@ -254,7 +258,7 @@ class DateRepeatTestCase extends DrupalWebTestCase {
     $result = implode(', ', $dates);
     $this->assertEqual($result, $shouldbe, $rule . '; Starting ' . $start . ';  results: ' . $result);
 
-    //Monthly on the third to the last day of the month, forever:
+    // Monthly on the third to the last day of the month, forever:
     $start = "1997-09-28 09:00:00";
     $end = "1998-03-01 09:00:00";
     $rule = "RRULE:FREQ=MONTHLY;BYMONTHDAY=-3";
@@ -266,7 +270,7 @@ class DateRepeatTestCase extends DrupalWebTestCase {
     $result = implode(', ', $dates);
     $this->assertEqual($result, $shouldbe, $rule . '; Starting ' . $start . ';  results: ' . $result);
 
-    //Every Thursday in March, forever:
+    // Every Thursday in March, forever:
     //  ==> (1997 9:00 AM EST)March 13,20,27
     //      (1998 9:00 AM EST)March 5,12,19,26
     //      (1999 9:00 AM EST)March 4,11,18,25
@@ -278,7 +282,7 @@ class DateRepeatTestCase extends DrupalWebTestCase {
     $result = implode(', ', $dates);
     $this->assertEqual($result, $shouldbe, $rule . '; Starting ' . $start . ';  results: ' . $result);
 
-    //Every Thursday, but only during June, July, and August, forever:
+    // Every Thursday, but only during June, July, and August, forever:
     //  ==> (1997 9:00 AM EDT)June 5,12,19,26;July 3,10,17,24,31;August 7,14,21,28
     //      (1998 9:00 AM EDT)June 4,11,18,25;July 2,9,16,23,30;August 6,13,20,27
     //      (1999 9:00 AM EDT)June 3,10,17,24;July 1,8,15,22,29;August 5,12,19,26
@@ -290,7 +294,7 @@ class DateRepeatTestCase extends DrupalWebTestCase {
     $result = implode(', ', $dates);
     $this->assertEqual($result, $shouldbe, $rule . '; Starting ' . $start . ';  results: ' . $result);
 
-    //Monthly on the 2nd and 15th of the month for 10 occurrences:
+    // Monthly on the 2nd and 15th of the month for 10 occurrences:
     //  ==> (1997 9:00 AM EDT)September 2,15;October 2,15
     //      (1997 9:00 AM EST)November 2,15;December 2,15
     //      (1998 9:00 AM EST)January 2,15
@@ -302,7 +306,7 @@ class DateRepeatTestCase extends DrupalWebTestCase {
     $result = implode(', ', $dates);
     $this->assertEqual($result, $shouldbe, $rule . '; Starting ' . $start . ';  results: ' . $result);
 
-    //Monthly on the first and last day of the month for 10 occurrences:
+    // Monthly on the first and last day of the month for 10 occurrences:
     //  ==> (1997 9:00 AM EDT)September 30;October 1
     //      (1997 9:00 AM EST)October 31;November 1,30;December 1,31
     //      (1998 9:00 AM EST)January 1,31;February 1
@@ -314,7 +318,7 @@ class DateRepeatTestCase extends DrupalWebTestCase {
     $result = implode(', ', $dates);
     $this->assertEqual($result, $shouldbe, $rule . '; Starting ' . $start . ';  results: ' . $result);
 
-    //Every Friday the 13th, forever:
+    // Every Friday the 13th, forever:
     $rule = "EXDATE;TZID=US-Eastern:19970902T090000";
     //  ==> (1998 9:00 AM EST)February 13;March 13;November 13
     //      (1999 9:00 AM EDT)August 13
@@ -327,7 +331,7 @@ class DateRepeatTestCase extends DrupalWebTestCase {
     $result = implode(', ', $dates);
     $this->assertEqual($result, $shouldbe, $rule . '; Starting ' . $start . ';  results: ' . $result);
 
-    //The first Saturday that follows the first Sunday of the month, forever:
+    // The first Saturday that follows the first Sunday of the month, forever:
     //  ==> (1997 9:00 AM EDT)September 13;October 11
     //      (1997 9:00 AM EST)November 8;December 13
     //      (1998 9:00 AM EST)January 10;February 7;March 7
@@ -340,8 +344,8 @@ class DateRepeatTestCase extends DrupalWebTestCase {
     $result = implode(', ', $dates);
     $this->assertEqual($result, $shouldbe, $rule . '; Starting ' . $start . ';  results: ' . $result);
 
-    //Every four years, the first Tuesday after a Monday in November,
-    //forever (U.S. Presidential Election day):
+    // Every four years, the first Tuesday after a Monday in November,
+    // forever (U.S. Presidential Election day):
     //  ==> (1996 9:00 AM EST)November 5
     //      (2000 9:00 AM EST)November 7
     //      (2004 9:00 AM EST)November 2
@@ -353,7 +357,7 @@ class DateRepeatTestCase extends DrupalWebTestCase {
     $result = implode(', ', $dates);
     $this->assertEqual($result, $shouldbe, $rule . '; Starting ' . $start . ';  results: ' . $result);
 
-    //Every 20th Monday of the year, forever:
+    // Every 20th Monday of the year, forever:
     $start = "1997-05-19 09:00:00";
     $end = "2000-01-01 09:00:00";
     $rule = "RRULE:FREQ=YEARLY;BYDAY=20MO";
@@ -365,7 +369,7 @@ class DateRepeatTestCase extends DrupalWebTestCase {
     $result = implode(', ', $dates);
     $this->assertEqual($result, $shouldbe, $rule . '; Starting ' . $start . ';  results: ' . $result);
 
-    //Every Sunday in January, every other year, forever:
+    // Every Sunday in January, every other year, forever:
     $start = "1997-01-05 09:00:00";
     $end = "2001-02-01 09:00:00";
     $rule = 'RRULE:FREQ=YEARLY;INTERVAL=2;BYMONTH=1;BYDAY=SU';
@@ -377,7 +381,7 @@ class DateRepeatTestCase extends DrupalWebTestCase {
     $result = implode(', ', $dates);
     $this->assertEqual($result, $shouldbe, $rule . '; Starting ' . $start . ';  results: ' . $result);
 
-    //Every Last Thursday in November, every year, five times:
+    // Every Last Thursday in November, every year, five times:
     $start = "2014-11-27 00:00:00";
     $rule = 'FREQ=YEARLY;INTERVAL=1;BYDAY=-1TH;BYMONTH=11;COUNT=5;WKST=SU';
     //  ==> (2014 00:00 AM EDT)November 27
@@ -390,9 +394,9 @@ class DateRepeatTestCase extends DrupalWebTestCase {
     $result = implode(', ', $dates);
     $this->assertEqual($result, $shouldbe, $rule . '; Starting ' . $start . ';  results: ' . $result);
 
-return;
+    return;
 
-    //Every Thanksgiving, forever:
+    // Every Thanksgiving, forever:
     $start = "1997-01-01 09:00:00";
     $end = "2001-02-01 09:00:00";
     $rule = 'RRULE:FREQ=YEARLY;INTERVAL=1;BYMONTH=11;BYDAY=4TH';
@@ -404,65 +408,57 @@ return;
     $result = implode(', ', $dates);
     $this->assertEqual($result, $shouldbe, $rule . '; Starting ' . $start . ';  results: ' . $result);
 
-// TODO:
-// BYYEARDAY, BYSETPOS,
-// BYHOUR, BYMINUTE, HOURLY, MINUTELY, SECONDLY
-// have not yet been implemented in date_repeat.
-
-//Every 3rd year on the 1st, 100th and 200th day for 10 occurrences:
-$date = "DTSTART;TZID=US-Eastern:19970101T090000";
-$rule = "RRULE:FREQ=YEARLY;INTERVAL=3;COUNT=10;BYYEARDAY=1,100,200";
-//  ==> (1997 9:00 AM EST)January 1
-//      (1997 9:00 AM EDT)April 10;July 19
-//      (2000 9:00 AM EST)January 1
-//      (2000 9:00 AM EDT)April 9;July 18
-//      (2003 9:00 AM EST)January 1
-//      (2003 9:00 AM EDT)April 10;July 19
-//      (2006 9:00 AM EST)January 1
-
-//Monday of week number 20 (where the default start of the week is Monday), forever:
-$date = "DTSTART;TZID=US-Eastern:19970512T090000";
-$rule = "RRULE:FREQ=YEARLY;BYWEEKNO=20;BYDAY=MO";
-//  ==> (1997 9:00 AM EDT)May 12
-//      (1998 9:00 AM EDT)May 11
-//      (1999 9:00 AM EDT)May 17
-
-//The 3rd instance into the month of one of Tuesday, Wednesday or
-//Thursday, for the next 3 months:
-$date = "DTSTART;TZID=US-Eastern:19970904T090000";
-$rule = "RRULE:FREQ=MONTHLY;COUNT=3;BYDAY=TU,WE,TH;BYSETPOS=3";
-//  ==> (1997 9:00 AM EDT)September 4;October 7
-//      (1997 9:00 AM EST)November 6
-
-//The 2nd to last weekday of the month:
-$date = "DTSTART;TZID=US-Eastern:19970929T090000";
-$rule = "RRULE:FREQ=MONTHLY;BYDAY=MO,TU,WE,TH,FR;BYSETPOS=-2";
-//  ==> (1997 9:00 AM EDT)September 29
-//      (1997 9:00 AM EST)October 30;November 27;December 30
-//      (1998 9:00 AM EST)January 29;February 26;March 30
-
-//Every 3 hours from 9:00 AM to 5:00 PM on a specific day:
-$date = "DTSTART;TZID=US-Eastern:19970902T090000";
-$rule = "RRULE:FREQ=HOURLY;INTERVAL=3;UNTIL=19970902T170000Z";
-//  ==> (September 2, 1997 EDT)09:00,12:00,15:00
-
-//Every 15 minutes for 6 occurrences:
-$date = "DTSTART;TZID=US-Eastern:19970902T090000";
-$rule = "RRULE:FREQ=MINUTELY;INTERVAL=15;COUNT=6";
-//  ==> (September 2, 1997 EDT)09:00,09:15,09:30,09:45,10:00,10:15
-
-//Every hour and a half for 4 occurrences:
-$date = "DTSTART;TZID=US-Eastern:19970902T090000";
-$rule = "RRULE:FREQ=MINUTELY;INTERVAL=90;COUNT=4";
-//  ==> (September 2, 1997 EDT)09:00,10:30;12:00;13:30
-
-//Every 20 minutes from 9:00 AM to 4:40 PM every day:
-$date = "DTSTART;TZID=US-Eastern:19970902T090000";
-$rule = "RRULE:FREQ=DAILY;BYHOUR=9,10,11,12,13,14,15,16;BYMINUTE=0,20,40";
-//  or
-$rule = "RRULE:FREQ=MINUTELY;INTERVAL=20;BYHOUR=9,10,11,12,13,14,15,16";
-//  ==> (September 2, 1997 EDT)9:00,9:20,9:40,10:00,10:20,16:00,16:20,16:40
-//      (September 3, 1997 EDT)9:00,9:20,9:40,10:00,10:20,16:00,16:20,16:40
-
+    // TODO:
+    // BYYEARDAY, BYSETPOS,
+    // BYHOUR, BYMINUTE, HOURLY, MINUTELY, SECONDLY
+    // have not yet been implemented in date_repeat.
+    // Every 3rd year on the 1st, 100th and 200th day for 10 occurrences:
+    $date = "DTSTART;TZID=US-Eastern:19970101T090000";
+    $rule = "RRULE:FREQ=YEARLY;INTERVAL=3;COUNT=10;BYYEARDAY=1,100,200";
+    //  ==> (1997 9:00 AM EST)January 1
+    //      (1997 9:00 AM EDT)April 10;July 19
+    //      (2000 9:00 AM EST)January 1
+    //      (2000 9:00 AM EDT)April 9;July 18
+    //      (2003 9:00 AM EST)January 1
+    //      (2003 9:00 AM EDT)April 10;July 19
+    //      (2006 9:00 AM EST)January 1
+    // Monday of week number 20 (where the default start of the week is Monday), forever:
+    $date = "DTSTART;TZID=US-Eastern:19970512T090000";
+    $rule = "RRULE:FREQ=YEARLY;BYWEEKNO=20;BYDAY=MO";
+    //  ==> (1997 9:00 AM EDT)May 12
+    //      (1998 9:00 AM EDT)May 11
+    //      (1999 9:00 AM EDT)May 17
+    // The 3rd instance into the month of one of Tuesday, Wednesday or
+    // Thursday, for the next 3 months:
+    $date = "DTSTART;TZID=US-Eastern:19970904T090000";
+    $rule = "RRULE:FREQ=MONTHLY;COUNT=3;BYDAY=TU,WE,TH;BYSETPOS=3";
+    //  ==> (1997 9:00 AM EDT)September 4;October 7
+    //      (1997 9:00 AM EST)November 6
+    // The 2nd to last weekday of the month:
+    $date = "DTSTART;TZID=US-Eastern:19970929T090000";
+    $rule = "RRULE:FREQ=MONTHLY;BYDAY=MO,TU,WE,TH,FR;BYSETPOS=-2";
+    //  ==> (1997 9:00 AM EDT)September 29
+    //      (1997 9:00 AM EST)October 30;November 27;December 30
+    //      (1998 9:00 AM EST)January 29;February 26;March 30
+    // Every 3 hours from 9:00 AM to 5:00 PM on a specific day:
+    $date = "DTSTART;TZID=US-Eastern:19970902T090000";
+    $rule = "RRULE:FREQ=HOURLY;INTERVAL=3;UNTIL=19970902T170000Z";
+    //  ==> (September 2, 1997 EDT)09:00,12:00,15:00
+    // Every 15 minutes for 6 occurrences:
+    $date = "DTSTART;TZID=US-Eastern:19970902T090000";
+    $rule = "RRULE:FREQ=MINUTELY;INTERVAL=15;COUNT=6";
+    //  ==> (September 2, 1997 EDT)09:00,09:15,09:30,09:45,10:00,10:15
+    // Every hour and a half for 4 occurrences:
+    $date = "DTSTART;TZID=US-Eastern:19970902T090000";
+    $rule = "RRULE:FREQ=MINUTELY;INTERVAL=90;COUNT=4";
+    //  ==> (September 2, 1997 EDT)09:00,10:30;12:00;13:30
+    // Every 20 minutes from 9:00 AM to 4:40 PM every day:
+    $date = "DTSTART;TZID=US-Eastern:19970902T090000";
+    $rule = "RRULE:FREQ=DAILY;BYHOUR=9,10,11,12,13,14,15,16;BYMINUTE=0,20,40";
+    //  or.
+    $rule = "RRULE:FREQ=MINUTELY;INTERVAL=20;BYHOUR=9,10,11,12,13,14,15,16";
+    //  ==> (September 2, 1997 EDT)9:00,9:20,9:40,10:00,10:20,16:00,16:20,16:40
+    //      (September 3, 1997 EDT)9:00,9:20,9:40,10:00,10:20,16:00,16:20,16:40
   }
+
 }
